from datetime import datetime
import pytz
import time as t
import application.Config.config as _config
Conf = _config.config
import json
import requests

class ServiceController(object):
    def __init__(self,msg):
        if msg.type == 26:
            txt = msg.message.text.lower()
            txt_ = txt.strip()
            if txt_ == 'gid':
                ServiceController._GID(msg)
            elif txt_ == 'uid':
                ServiceController.get_uid(msg)
            elif txt_ == 'total':
                ServiceController._Total(msg)
            elif txt_ == 'lst1':
                ServiceController._LEAVE(msg)
            elif txt_ == '@@'or txt_ == 'แทค' or txt_ == 'tag':
                ServiceController.TagMember(msg)
            elif txt_ == 'st:start' or txt_ == 'เปิดผลหุ้น' or txt_ == 'เปิดหุ้น' or txt_ == 'เปิดผล':
                ServiceController._Hon(msg)
            elif txt_ == 'st:stop' or txt_ == 'ปิดผลหุ้น' or txt_ == 'ปิดหุ้น' or txt_ == 'ปิดผล':
                ServiceController._Hoff(msg)
            elif txt_ == 'st:active':
                ServiceController.bot_active(msg)
            elif txt_ == 'sta:on':
                ServiceController.bot_alert_on(msg)
            elif txt_ == 'sta:off':
                ServiceController.bot_alert_off(msg)
            elif txt_ == 'st:status' or txt_ == 'สถานะ' or txt_ == 'status':
                ServiceController.bot_status(msg)
            elif txt_ == 'st:s1':
                msg.loop = 'single'
                ServiceController._mode_(msg)
            elif txt_ == 'ผลหุ้น' or txt_ == 'ผลรวม':
                ServiceController.result(msg)
            elif txt_[0:3] == "###":
                msg.stock_name = txt_
                ServiceController.changeModGroup(msg)
            elif txt_[0:2] == "##":
                msg.stock_name = txt_
                ServiceController.changeMod(msg)
            elif txt_[0:1] == "#":
                msg.stock_name = txt_[1:5]
                #ServiceController.result_history(msg) ปิดชั่วคราว
                # ServiceController.result_history_10line(msg)
            elif txt_[0:1] == "/":
                msg.stock_name = txt_[1:5]
                ServiceController.result_history_10line(msg)
            elif txt_ == 'testspeed':
                ServiceController.test_speed(msg)
            elif txt_ == '@reset_bot':
                ServiceController._LEAVE_ALL(msg)
            elif txt_ == '!บช':
                ServiceController._clearBank(msg)
            elif txt_ in ['bot','บอท']:
                ServiceController._bot(msg)
            else:
                another = txt_.split(' ')
                if another[0] == 'บช' or txt_ == 'บัญชีโอนเงิน' or txt_ == 'บัญชี':
                	ServiceController._showBank(msg)
                elif another[0] == 'ตั้งข้อความ':
                	if len(another) != 1:
                		msg.fixtext = another
                		ServiceController._updateText(msg)
                elif another[0] == 'ตั้งบช':
                	if len(another) != 1:
                		msg.fixtext = another
                		ServiceController._updatBank(msg)
	#------------------------------------------------------------------#
    def _getNumber(_number):
        _res = requests.get("http://104.238.148.82/v2/command/number.json")
        _text = _res.json()
        return _text[str(_number)]

    def _getLabelList():
        _res = requests.get("http://104.238.148.82/v2/command/name.json")
        _text = _res.json()
        return _text

    def changeModGroup(self):
        try:
            _query = self.stock_name #"##2:on" ## input bot
            _gid = self.message.to #"cb7b9af05988f8b6f72a19bf3ca1a4ec7" ## input bot
            if _query[0:3] == "###":
            	fileter = _query[3:10]
            	if fileter == "เปิดนอก":
                	_name = "1"
                	_status = "1"
            	elif fileter == "ปิดนอก":
                	_name = "1"
                	_status = "0"

            	elif fileter == "เปิดลาว":
                	_name = "2"
                	_status = "1"
            	elif fileter == "ปิดลาว":
                	_name = "2"
                	_status = "0"

            	elif fileter == "เปิดนอย":
                	_name = "3"
                	_status = "1"
            	elif fileter == "ปิดนอย":
                	_name = "3"
                	_status = "0"

            	elif fileter == "เปิดไทย":
                	_name = "4"
                	_status = "1"
            	elif fileter == "ปิดไทย":
                	_name = "4"
                	_status = "0"

            	elif fileter == "เปิดวี":
                	_name = "5"
                	_status = "1"
            	elif fileter == "ปิดวี":
                	_name = "5"
                	_status = "0"

            	_l = "✅ เปิดการใช้ผล ✅"
            	_s = "✅"
            	if _status == "0":
            	    _l = "❌ ปิดการใช้ผล ❌"
            	    _s = "❌"

            	_url = "http://150.95.89.148/api/py/forbot/update_status_stock_group.php?gid="+str(_gid)+"&status="+str(_status)+"&name="+str(_name)
            	_res = requests.get(_url)
            	_text = _res.json()
            	_numberList = ServiceController._getLabelList()
            	msg_set = "☣อัพเดทสถานะ☣\n􂠁􀅦-􏿿􂠁􀅦-􏿿􂠁􀅦-􏿿􂠁􀅦-􏿿􂠁􀅦-􏿿\n\n"
            	for _list in _text["list"]:
            	    msg_set = msg_set+_s+" "+_numberList[_list]+"\n"
            	msg_set = msg_set+"\n􂠁􀅦-􏿿􂠁􀅦-􏿿􂠁􀅦-􏿿􂠁􀅦-􏿿􂠁􀅦-􏿿\n"
            	msg_set = msg_set+"\n"+_l+"\n"
            	msg_set = msg_set+"\n"+"􀼂􀅝church􏿿􀼂􀅜arbor􏿿﹏􀼂􀆻lovebirds􏿿􀼂􀆻lovebirds􏿿﹏􀼂􀅜arbor􏿿􀼂􀅝church􏿿"
            	self.mybot.sendMessage(self.message.to,msg_set)
        except Exception as err:
            print('error ', err)

    def changeMod(self):
        try:
            _query = self.stock_name #"##2:on" ## input bot
            _gid = self.message.to #"cb7b9af05988f8b6f72a19bf3ca1a4ec7" ## input bot
            if _query[0:2] == "##":
            	fileter = _query[2:11]
            	_filter = fileter.split(':')
            	_name = ServiceController._getNumber(_filter[0])
            	if _filter[1] == "on":
            	    _status = "1"
            	    _l = "✅ เปิดการใช้ผล ✅"
            	    _url = "http://150.95.89.148/api/py/forbot/update_status_stock.php?gid="+str(_gid)+"&status="+str(_status)+"&name="+str(_name[0])
            	    _res = requests.get(_url)
            	    self.mybot.sendMessage(self.message.to, "☣อัพเดทสถานะแล้ว☣\n\n ผล "+_name[1]+"\n\n"+_l)
            	elif _filter[1] == "off":
            	    _status = "0"
            	    _l = "❌ ปิดการใช้ผล ❌"
            	    _url = "http://150.95.89.148/api/py/forbot/update_status_stock.php?gid="+str(_gid)+"&status="+str(_status)+"&name="+str(_name[0])
            	    _res = requests.get(_url)
            	    self.mybot.sendMessage(self.message.to, "☣อัพเดทสถานะแล้ว☣\n\n ผล "+_name[1]+"\n\n"+_l)
            	elif _filter[1] == "status":
            	    _status = "2"
            	    _url = "http://150.95.89.148/api/py/forbot/get_status_stock.php?gid="+str(_gid)+"&status="+str(_status)+"&name="+str(_name[0])
            	    _res = requests.get(_url)
            	    _text = _res.json()
            	    _txt = "❌ ปิดใช้งานอยู่ ❌"
            	    if str(_text[_name[0]]) == "1":
                		_txt  = "✅ เปิดใช้งานอยู่ ✅"
            	    self.mybot.sendMessage(self.message.to, "☣สถานะการแสดงผล☣\n\n"+"=> ผล"+_name[1]+"\n\n"+_txt+"\n")
        except Exception as err:
            print('error ', err)
    def get_uid(self):
        try:
            _Profile = self.mybot.getProfile()
            self.mybot.sendMessage(self.message.to, _Profile.mid)
        except :
            pass
    def test_speed(self):
        start = t.time()
        self.mybot.sendMessage(self.message.to, "Prosses...")
        elapsed_time = t.time() - start
        self.mybot.sendMessage(self.message.to,format(str(elapsed_time)))
    def _clearBank(self):
        try:
            # clear text
            url_ = str(self.autoload._config._url_api())+'/bank/clear.php?gid=' + \
                str(self.message.to)+'&p='+str(self.autoload._config._name())
            print(url_)
            update_text = requests.get(url_)
            _update_text = update_text.json()
            if _update_text['status']:
            	self.mybot.sendMessage(self.message.to, "✅ ลบ บัญชี สำเร็จแล้ว")
            else:
            	self.mybot.sendMessage(
            	    self.message.to, "❌เกิดข้อผิดพลาด กรุณาติดต่อผู้ให้เช่าบอท")
        except Exception as err:
            print('error ', err)
    def _updatBank(self):
        try:
            alltext = ''
            for i in range(len(self.fixtext)):
            	if i != 0:
            		alltext+= ' '+str(self.fixtext[(i)])
            self.mybot.sendMessage(self.message.to, 'อัพเดท....')
            self.mybot.sendMessage(self.message.to, 'ข้อมูล บัญชีของท่านคือ')
            self.mybot.sendMessage(self.message.to, alltext)
            # Filter
            filter_text = requests.get(str(self.autoload._config._url_api())+'/filter_input/link.php?txt='+str(alltext).strip())
            _filter_text = filter_text.json()
            # update text
            url_ = str(self.autoload._config._url_api())+'/bank/update_stock.php?gid='+str(self.message.to)+'&p='+str(self.autoload._config._name())+'&txt='+str(_filter_text['text']).strip()
            update_text = requests.get(url_)
            _update_text = update_text.json()
            if _update_text['status']:
            	self.mybot.sendMessage(self.message.to, "✅บันทึก เลข บัญชีแล้ว\nสามารถเรียกใช้โดยพิมว่า\nบช\n ครับ")
            else:
            	self.mybot.sendMessage(self.message.to, "❌เกิดข้อผิดพลาด กรุณาติดต่อผู้ให้เช่าบอท")
        except Exception as err:
            print('error ',err)
    def _showBank(self):
        try:
            url_ = str(self.autoload._config._url_api())+'/get_user_filter_stock.php?gid='+str(self.message.to)+'&p='+str(self.autoload._config._name())
            update_text = requests.get(url_)
            _update_text = update_text.json()
            try:
            	if _update_text[0]['groupline_bank_image'] != None:
            		self.mybot.sendImageWithURL(self.message.to, _update_text[0]['groupline_bank_image'])
            except Exception as err:
            	print('error ',err)
            if _update_text[0]['groupline_bank'] != None:
            	self.mybot.sendMessage(self.message.to, _update_text[0]['groupline_bank'])
            # else:
            # 	self.mybot.sendMessage(self.message.to, "⚠ ยังไม่ได้ระบุ\n กรุณาส่ข้อมูลก่อน\nขั้นตอนใช่ข้อมูล \nพิม บช {เลข บช ที่ต้องการ}")
        except Exception as err:
            print('error ',err)
    def _Hon(self):
        try:
            url_ = str(self.autoload._config._url_api())+'/on_off/status.php?gid='+str(self.message.to)+'&p='+str(self.autoload._config._name())+'&s=run'
            update_text = requests.get(url_)
            _update_text = update_text.json()
            if _update_text['status']:
            	self.mybot.sendMessage(self.message.to, "⏯เปิดใช้งานบอทแล้ว\n พิม ST:STOP เพื่อปิดให้งาน")
            else:
            	self.mybot.sendMessage(self.message.to, "❌มีปัญหา กรุณาติดต่อเจ้าของบอท")
        except Exception as err:
            print('error ',err)
    def _Hoff(self):
        try:
            url_ = str(self.autoload._config._url_api())+'/on_off/status.php?gid='+str(self.message.to)+'&p='+str(self.autoload._config._name())+'&s=stop'
            update_text = requests.get(url_)
            _update_text = update_text.json()
            if _update_text['status']:
            	self.mybot.sendMessage(self.message.to, "⏹หยุดรันผลแล้ว \n พิม ST:START เพื่อเปิดให้งาน")
            else:
            	self.mybot.sendMessage(self.message.to, "❌มีปัญหา กรุณาติดต่อเจ้าของบอท")
        except Exception as err:
            print('error ',err)
    def _Total(self):
        try:
            gid = self.mybot.getGroupIdsJoined()
            members = len(gid)
            self.mybot.sendMessage(self.message.to, 'จำนวนกลุ่ม : '+str(members)+' กลุ่ม' )
        except Exception as err:
            print('error ',err)
    def _updateText(self):
        try:
            alltext = ''
            for i in range(len(self.fixtext)):
            	if i != 0:
            		alltext+= ' '+str(self.fixtext[(i)])
            self.mybot.sendMessage(self.message.to, 'อัพเดท....')
            self.mybot.sendMessage(self.message.to, 'ข้อความของท่าน คือ')
            self.mybot.sendMessage(self.message.to, alltext)
            # Filter
            filter_text = requests.get(str(self.autoload._config._url_api())+'/filter_input/link.php?txt='+str(alltext).strip())
            _filter_text = filter_text.json()
            # update text
            url_ = str(self.autoload._config._url_api())+'/text/update.php?gid='+str(self.message.to)+'&p='+str(self.autoload._config._name())+'&txt='+str(_filter_text['text']).strip()
            update_text = requests.get(url_)
            _update_text = update_text.json()
            if _update_text['status']:
            	self.mybot.sendMessage(self.message.to, "✅ข้อความจะโชว์ในรอบถัดไป ค่ะ")
            else:
            	self.mybot.sendMessage(self.message.to, "❌เกิดข้อผิดพลาด กรุณาติดต่อผู้ให้เช่าบอท")
        except Exception as err:
            print('error ',err)
    def _GID(self):
        try: 
            self.mybot.sendMessage(self.message.to, "รหัสกลุ่มคือ")
            self.mybot.sendMessage(self.message.to, self.message.to)
        except Exception as err:
            print('error ',err)
    def _LEAVE(self):
            self.mybot.sendMessage(self.message.to,'😊ขอบคุณที่ใช้บริการ😊')
            leave = self.mybot.leaveGroup(self.message.to)
    # เปิดใช้งาน แค่ รันใหม่ ไม่ให้เปิดค้างไว้
    def _LEAVE_ALL(self):
        print('sleep function')
        # try:
        #     gid = self.mybot.getGroupIdsJoined()
        #     for e in gid:
        #         if e != 'cda0b7ff5b7ac1329f1ad6316ae3afc48' and e != 'cc7a4032f71810699742a58cc3c3bb044' and e != 'ccb13d1004cef4eff0eb7a11a33b8cc55' :
        #             try:
        #                 self.mybot.sendMessage(e,'@mybot รายงานผล ระบบเก่า ขออนุญาต ออกจากกลุ่ม เพื่อนำไปรันผลเว็บใหม่ KERRY889 (การออกกลุ่ม ไม่กระทบกับบอทที่ทำงานอยู่ครับ)')
        #                 self.mybot.sendMessage(e,'สนใจเช่าบอทรายงานผล')
        #                 self.mybot.sendMessage(e,'line://ti/p/~@mybot')
        #                 self.mybot.sendMessage(e,'😊ขอบคุณที่ใช้บริการ😊')
        #                 self.mybot.leaveGroup(e)
        #             except Exception as err:
        #                 print('error ',e)
        # except Exception as err:
        #     print('error ',err)                  
    def TagMember(self):
        self.mybot.sendMessage(self.message.to, "👱‍♂️โหลดสมาชิกทั้งหมด👩‍🦳")
        group = self.mybot.getGroup(self.message.to)
        nama = [contact.mid for contact in group.members]
        k = len(nama)//20
        for a in range(k+1):
            txt = u''
            s=0
            b=[]
            for i in group.members[a*20 : (a+1)*20]:
                b.append({"S":str(s), "E" :str(s+6), "M":i.mid})
                s += 7
                txt += u'@Alin \n'

            self.mybot.sendMessage(self.message.to, text=txt, contentMetadata={u'MENTION': json.dumps({'MENTIONEES':b})}, contentType=0)
        self.mybot.sendMessage(self.message.to, "จำนวนทั้งหมด {} คน".format(str(len(nama))))
    def bot_active(self):
        try:
            url_ = str(self.autoload._config._url_api())+'/get_user_filter_multi.php?gid='+str(self.message.to)+'&p='+str(self.autoload._config._name())
            update_text = requests.get(url_)
            _update_text = update_text.json()
            if _update_text[0]['groupline_access'] == 'padding':
            	group = self.mybot.getGroup(self.message.to)
            	t.sleep(0.5)
            	self.mybot.sendMessage(self.message.to,"กรุณาคัดลอกข้อความด้านล่าง\nส่งกลับไปให้ผู้ติดบอท\nเพื่อรันผลครับ\n⬇⬇⬇⬇⬇⬇")
            	t.sleep(0.5)
            	self.mybot.sendMessage(self.message.to,"ชื่อกลุ่ม : "+str(group.name)+"\nบอทรายผล : "+str(self.autoload._config._name())+"\nรหัสกลุ่ม : "+str(_update_text[0]['groupline_id'])+"\n"+str(self.message.to))   
            	t.sleep(0.5)
            	self.mybot.sendMessage(self.message.to,"⬆⬆⬆⬆⬆⬆")
            elif _update_text[0]['groupline_access'] == 'stop':
            	self.mybot.sendMessage(self.message.to,'❌บอทหมดอายุแล้ว\nกรุณาติดต่อ @mybot\nเพิ่มต่ออายุครับ')
            elif _update_text[0]['groupline_access'] == 'active':
            	self.mybot.sendMessage(self.message.to, "เปิดให้งานอยู่แล้ว")
            	_start = datetime.strptime(_update_text[0]['groupline_buy_date'], '%Y-%m-%d')
            	YY = str(int(_start.year)+543)
            	D = str(_start.day)
            	month_name = 'x มกราคม กุมภาพันธ์ มีนาคม เมษายน พฤษภาคม มิถุนายน กรกฎาคม สิงหาคม กันยายน ตุลาคม พฤศจิกายน ธันวาคม'.split()[_start.month]
            	start = D+' '+month_name+' '+YY

            	_end = datetime.strptime(_update_text[0]['groupline_buy_end'], '%Y-%m-%d')
            	YY = str(int(_end.year)+543)
            	D = str(_end.day)
            	month_name = 'x มกราคม กุมภาพันธ์ มีนาคม เมษายน พฤษภาคม มิถุนายน กรกฎาคม สิงหาคม กันยายน ตุลาคม พฤศจิกายน ธันวาคม'.split()[_end.month]
            	end = D+' '+month_name+' '+YY
            	groupline_status = str(_update_text[0]['groupline_status'])
            	groupline_version = str(_update_text[0]['groupline_version'])
            	groupline_theme = str(_update_text[0]['groupline_theme'])
            	groupline_block = str(_update_text[0]['groupline_block'])
            	groupline_over_alert = str(_update_text[0]['groupline_over_alert'])
            	groupline_encode = str(_update_text[0]['groupline_id'])  
            	groupline_welcome = str(_update_text[0]['groupline_welcome'])  
            	# groupline_encode= str(_update_text[0]['groupline_encode'])
            	if groupline_status == 'run':
            		groupline_status = 'เปิดใช้งาน'
            	else: 
            		groupline_status = 'ปิดใช้งาน'            	
            	if groupline_over_alert == 'on':
            		groupline_over_alert = 'เปิด'
            	else: 
            		groupline_over_alert = 'ปิด'
            	if groupline_block == 'ON':
            		groupline_block = 'เปิด'
            	else: 
            		groupline_block = 'ปิด'
            	if groupline_welcome == 'ON':
            		groupline_welcome = 'เปิด'
            	else: 
            		groupline_welcome = 'ปิด'
            	view = "      สถานะบอท\n" + \
            	"🆗 เปิดใช้งานแล้ว 🆗\n" + \
            	"     เปิดใช้งานเมื่อ \n" + \
            	"   "+str(start)+"\n" + \
            	"     หมดอายุวันที่\n" + \
            	"  " +str(end) + "\n" + \
            	"  *******************\n" + \
            	"   บอทเวอร์ชั่น : " + groupline_version + "\n" + \
            	"   สถานะ : " + groupline_status + "\n" + \
            	"  รันผลแบบ : " + groupline_theme + "\n" + \
            	"  ไม้กั้นผล(ซม) : " + groupline_block + "\n" + \
            	" เตือนหมดเวลา : " + groupline_over_alert + "\n" + \
            	" ข้อความต้อนรับ : " + groupline_welcome + "\n" + \
            	"   รหัสกลุ่ม : " + groupline_encode
            	self.mybot.sendMessage(self.message.to, view)
        except Exception as err:
            print('error ',err)
    def bot_alert_on(self):
        try:
            url_ = str(self.autoload._config._url_api())+'/alert/alert.php?p='+str(self.autoload._config._name())+'&mode=on&gid='+str(self.message.to)
            mode = requests.get(url_)
            _mode = mode.json()
            if _mode['status'] == True:
            	self.mybot.sendMessage(self.message.to, "เปิดเตือนหมดเวลาแล้ว✅")
            else:
            	self.mybot.sendMessage(self.message.to, "มีปัญหากรุณาติดต่อ\nแอดมิน")
        except Exception as err:
            print('error ',err)
    def bot_alert_off(self):
        try:
            url_ = str(self.autoload._config._url_api())+'/alert/alert.php?p='+str(self.autoload._config._name())+'&mode=off&gid='+str(self.message.to)
            mode = requests.get(url_)
            _mode = mode.json()
            if _mode['status'] == True:
            	self.mybot.sendMessage(self.message.to, "ปิดเตือนหมดเวลาแล้ว⭕")
            else:
            	self.mybot.sendMessage(self.message.to, "มีปัญหากรุณาติดต่อ\nแอดมิน")
        except Exception as err:
            print('error ',err)
    def bot_status(self):
        try:
            url_ = str(self.autoload._config._url_api())+'/get_user_filter.php?gid='+str(self.message.to)+'&p='+str(self.autoload._config._name())
            update_text = requests.get(url_)
            _update_text = update_text.json()
            if _update_text[0]['groupline_access'] == 'active':
            	try:
            		_start = datetime.strptime(_update_text[0]['groupline_buy_date'], '%Y-%m-%d')
            		YY = str(int(_start.year)+543)
            		D = str(_start.day)
            		month_name = 'x มกราคม กุมภาพันธ์ มีนาคม เมษายน พฤษภาคม มิถุนายน กรกฎาคม สิงหาคม กันยายน ตุลาคม พฤศจิกายน ธันวาคม'.split()[_start.month]
            		start = D+' '+month_name+' '+YY

            		_end = datetime.strptime(_update_text[0]['groupline_buy_end'], '%Y-%m-%d')
            		YY = str(int(_end.year)+543)
            		D = str(_end.day)
            		month_name = 'x มกราคม กุมภาพันธ์ มีนาคม เมษายน พฤษภาคม มิถุนายน กรกฎาคม สิงหาคม กันยายน ตุลาคม พฤศจิกายน ธันวาคม'.split()[_end.month]
            		end = D+' '+month_name+' '+YY
            	except Exception as err: 
            		start = "ยังไม่ระบุวันที่เริ่ม"
            		end = "ยังไม่ระบุวันที่หมด"

            	groupline_status = str(_update_text[0]['groupline_status'])
            	groupline_version = str(_update_text[0]['groupline_version'])
            	groupline_theme = str(_update_text[0]['groupline_theme'])
            	groupline_block = str(_update_text[0]['groupline_block'])
            	groupline_over_alert = str(_update_text[0]['groupline_over_alert'])
            	groupline_encode= str(_update_text[0]['groupline_id'])           	
            	# groupline_encode= str(_update_text[0]['groupline_encode'])
            	groupline_welcome= str(_update_text[0]['groupline_welcome'])
            	if groupline_status == 'run':
            		groupline_status = 'เปิดใช้งาน'
            	else: 
            		groupline_status = 'ปิดใช้งาน'            	
            	if groupline_over_alert == 'on':
            		groupline_over_alert = 'เปิด'
            	else: 
            		groupline_over_alert = 'ปิด'
            	if groupline_block == 'ON':
            		groupline_block = 'เปิด'
            	else: 
            		groupline_block = 'ปิด'
            	if groupline_welcome == 'ON':
            		groupline_welcome = 'เปิด'
            	else: 
            		groupline_welcome = 'ปิด'
            	if groupline_theme == 'single':
            		groupline_theme = '1'
            	else: 
            		groupline_theme = groupline_theme.replace("line", "")

            	groupline_products = str(_update_text[0]['groupline_products'])

            	view = "      สถานะบอท\n" + \
            	"🆗 เปิดใช้งานแล้ว 🆗\n" + \
            	"     เปิดใช้งานเมื่อ \n" + \
            	"   "+str(start)+"\n" + \
            	"     หมดอายุวันที่\n" + \
            	"  " +str(end) + "\n" + \
            	"********************\n" + \
                " รันผล :"+groupline_products+"\n"+\
            	"   บอทเวอร์ชั่น : " + groupline_version + "\n" + \
            	"   สถานะ : " + groupline_status + "\n" + \
            	"  รันผลแบบ : " + groupline_theme + " แถว\n" + \
            	"  ไม้กั้นผล(ซม) : " + groupline_block + "\n" + \
            	" เตือนหมดเวลา : " + groupline_over_alert + "\n" + \
            	" ข้อความต้อนรับ : " + groupline_welcome + "\n" + \
            	"   รหัสกลุ่ม : " + groupline_encode+ "\n" + \
            	"➖➖➖➖➖➖➖\n" + \
            	"BOT VERSION "+str(self.autoload._config._building_version())
            	self.mybot.sendMessage(self.message.to, view)
            else:
            	self.mybot.sendMessage(self.message.to, "❌ยังไม่ได้เปิดใช้งาน")
        except Exception as err:
            print('error ',err)
	#MODE 
    def _mode_(self):
        try:
            url_ = str(self.autoload._config._url_api())+'/mode/mode.php?mode='+str(self.loop)+'&p='+str(self.autoload._config._name())+'&gid='+str(self.message.to)
            mode = requests.get(url_)
            _mode = mode.json()
            if _mode['status'] == True:
            	if self.loop == 'single':
            		self.loop = '1'
            	elif self.loop == '5line':
            		self.loop = '5'
            	elif self.loop == '10line':
            		self.loop = '10'
            	elif self.loop == '15line':
            		self.loop = '15'
            	elif self.loop == '20line':
            		self.loop = '20'
            	elif self.loop == '25line':
            		self.loop = '25'
            	elif self.loop == '30line':
            		self.loop = '30'
            	elif self.loop == '40line':
            		self.loop = '40'
            	elif self.loop == '50line':
            		self.loop = '50'
            	self.mybot.sendMessage(self.message.to, "เปลี่ยนโหมด เสร็จแล้ว✅\n➖➖➖➖➖➖➖➖\nใช้โหมดธรรมดา "+str(self.loop)+" แถวแล้ว")
            else:
            	self.mybot.sendMessage(self.message.to, "มีปัญหากรุณาติดต่อ\nแอดมิน")
        except Exception as err:
            print('error ',err)

    def result(self):
        tz_NY = pytz.timezone('Asia/Bangkok') 
        # show footer time
        now1 = datetime.now(tz_NY)
        month_name = 'x มกราคม กุมภาพันธ์ มีนาคม เมษายน พฤษภาคม มิถุนายน กรกฎาคม สิงหาคม กันยายน ตุลาคม พฤศจิกายน ธันวาคม'.split()[now1.month]
        thai_year = now1.year + 543
        time_str = now1.strftime('%H:%M:%S')
        show_date = "%d %s %d"%(now1.day, month_name, thai_year) # 30 ตุลาคม 2560 # disabled -> 20:45:30
        # res = requests.get('http://104.238.148.82/api/jowmuu_stock_result.php')
        # result = res.json()
        try: 
            # self.mybot.sendMessage(self.message.to, "➖➖➖➖➖➖➖➖➖\n" + \
        #     " 🛠ผล หุ้นไทย/นอก 65 ผล🛠\n" + \
        #     "➖➖➖➖➖➖➖➖➖\n" + \
        #     "01.🇯🇵นิเคอิเช้า ➡️ "+result["result"][0]["_ST_01"]+"\n" + \
        #     "02.🇨🇳จีนเช้า ➡️ "+result["result"][0]["_ST_02"]+"\n" + \
        #     "03.🇭🇰ฮั่งเส็งเช้า ➡️ "+result["result"][0]["_ST_03"]+"\n" + \
        #     "04.🇹🇼ไต้หวัน ➡️ "+result["result"][0]["_ST_04"]+"\n" + \
        #     "05.🇰🇷เกาหลี ➡️ "+result["result"][0]["_ST_05"]+"\n" + \
        #     "06.🇯🇵นิเคอิบ่าย ➡️ "+result["result"][0]["_ST_01_M"]+"\n" + \
        #     "07.🇨🇳จีนบ่าย ➡️ "+result["result"][0]["_ST_02_M"]+"\n" + \
        #     "08.🇭🇰ฮั่งเส็งบ่าย ➡️ "+result["result"][0]["_ST_03_M"]+"\n" + \
        #     "09.🇸🇬สิงคโปร์ ➡️ "+result["result"][0]["_ST_06"]+"\n" + \
        #     "10.🇱🇦หวยลาว ➡️ "+result["result"][0]["_ST_13"]+"\n" + \
        #     "11.🇮🇳อินเดีย ➡️ "+result["result"][0]["_ST_07"]+"\n" + \
        #     "12.🇩🇪เยอรมัน ➡️ "+result["result"][0]["_ST_10"]+"\n" + \
        #     "13.🇾🇪อียิปต์ ➡️ "+result["result"][0]["_ST_08"]+"\n" + \
        #     "14.🇷🇺รัสเซีย ➡️ "+result["result"][0]["_ST_09"]+"\n" + \
        #     "15.🏴󠁧󠁢󠁥󠁮󠁧󠁿อังกฤษ ➡️ "+result["result"][0]["_ST_11"]+"\n" + \
        #     "16.🇺🇸ดาวโจนส์ ➡️ "+result["result"][0]["_ST_00"]+"\n" + \
        #     "➖กลุ่มผลไทย-เวียดนาม➖"+"\n" + \
        #     "17.🇹🇭ไทยเช้า ➡️ "+result["result"][0]["_TH_01"]+"\n" + \
        #     "18.🇹🇭ไทยเช้า ตลาด ➡️ "+result["result"][0]["_TH_01_M"]+"\n" + \
        #     "19.🇹🇭ไทยเที่ยง ➡️ "+result["result"][0]["_TH_02"]+"\n" + \
        #     "20.🇹🇭ไทยบ่าย ➡️ "+result["result"][0]["_TH_03"]+"\n" + \
        #     "21.🇹🇭ไทยบ่าย ตลาด ➡️ "+result["result"][0]["_TH_03_M"]+"\n" + \
        #     "22.🇹🇭ไทยเย็น ➡️ "+result["result"][0]["_TH_04"]+"\n" + \
        #     "23.🇻🇳ฮานอย ➡️ "+result["result"][0]["_ST_14"]+"\n" + \
        #     "24.🇻🇳ฮานอย VIP ➡️ "+result["result"][0]["_ST_15"]+"\n" + \
        #     "25.🇻🇳ฮานอย พิเศษ ➡️ "+result["result"][0]["_ST_16"]+"\n" + \
        #     "26.🇲🇾มาเลย์ ➡️ "+result["result"][0]["_ST_12"]+"\n" + \
        #     "➖➖ติดต่อเช่าบอทที่➖➖\n" + \
        #     "💕 line://ti/p/~@mybot 💕" )
            _load = requests.get("http://104.238.148.82/v2/command/menu.json")
            _load_json = _load.json()
            _result1 = _load_json[0]['header']+"\n[ "+show_date+" ]\n􂠁􀅦-􏿿􂠁􀅦-􏿿􂠁􀅦-􏿿􂠁􀅦-􏿿􂠁􀅦-􏿿\n"+_load_json[0]['body']+"􂠁􀅦-􏿿􂠁􀅦-􏿿􂠁􀅦-􏿿􂠁􀅦-􏿿􂠁􀅦-􏿿\n"+_load_json[0]['footer']
            _result2 = _load_json[1]['header']+"\n[ "+show_date+" ]\n􂠁􀅦-􏿿􂠁􀅦-􏿿􂠁􀅦-􏿿􂠁􀅦-􏿿􂠁􀅦-􏿿\n"+_load_json[1]['body']+"􂠁􀅦-􏿿􂠁􀅦-􏿿􂠁􀅦-􏿿􂠁􀅦-􏿿􂠁􀅦-􏿿\n"+_load_json[1]['footer']
            _result3 = _load_json[2]['header']+"\n[ "+show_date+" ]\n􂠁􀅦-􏿿􂠁􀅦-􏿿􂠁􀅦-􏿿􂠁􀅦-􏿿􂠁􀅦-􏿿\n"+_load_json[2]['body']+"􂠁􀅦-􏿿􂠁􀅦-􏿿􂠁􀅦-􏿿􂠁􀅦-􏿿􂠁􀅦-􏿿\n"+_load_json[2]['footer']
            _result4 = _load_json[3]['header']+"\n[ "+show_date+" ]\n􂠁􀅦-􏿿􂠁􀅦-􏿿􂠁􀅦-􏿿􂠁􀅦-􏿿􂠁􀅦-􏿿\n"+_load_json[3]['body']+"􂠁􀅦-􏿿􂠁􀅦-􏿿􂠁􀅦-􏿿􂠁􀅦-􏿿􂠁􀅦-􏿿\n"+_load_json[3]['footer']
            _result5 = _load_json[4]['header']+"\n[ "+show_date+" ]\n􂠁􀅦-􏿿􂠁􀅦-􏿿􂠁􀅦-􏿿􂠁􀅦-􏿿􂠁􀅦-􏿿\n"+_load_json[4]['body']+"􂠁􀅦-􏿿􂠁􀅦-􏿿􂠁􀅦-􏿿􂠁􀅦-􏿿􂠁􀅦-􏿿\n"+_load_json[4]['footer']
            self.mybot.sendMessage(self.message.to, _result1)
            t.sleep(1)
            self.mybot.sendMessage(self.message.to, _result2)
            t.sleep(1)
            self.mybot.sendMessage(self.message.to, _result3)
            t.sleep(1)
            self.mybot.sendMessage(self.message.to, _result4)
            t.sleep(1)
            self.mybot.sendMessage(self.message.to, _result5)
        except Exception as err:
            print('error ',err)

    def result_history(self):
        res = requests.get('http://104.238.148.82/api/jowmuu_stock_history_data.php?loop='+self.stock_name)
        result = res.json()
        try: 
            self.mybot.sendMessage(self.message.to, result[0]['lottery_name']+"\n􂠁􀅦-􏿿􂠁􀅦-􏿿􂠁􀅦-􏿿􂠁􀅦-􏿿􂠁􀅦-􏿿\n" + \
            " ⬇️ผล ย้อนหลัง 30 วัน ⬇️\n" + \
            "􂠁􀅦-􏿿􂠁􀅦-􏿿􂠁􀅦-􏿿􂠁􀅦-􏿿􂠁􀅦-􏿿\n" + \
            ""+result[0]['lottery_loop_30']+"\n" + \
            ""+result[0]['lottery_loop_29']+"\n" + \
            ""+result[0]['lottery_loop_28']+"\n" + \
            ""+result[0]['lottery_loop_27']+"\n" + \
            ""+result[0]['lottery_loop_26']+"\n" + \
            ""+result[0]['lottery_loop_25']+"\n" + \
            ""+result[0]['lottery_loop_24']+"\n" + \
            ""+result[0]['lottery_loop_23']+"\n" + \
            ""+result[0]['lottery_loop_22']+"\n" + \
            ""+result[0]['lottery_loop_21']+"\n" + \
            ""+result[0]['lottery_loop_20']+"\n" + \
            ""+result[0]['lottery_loop_19']+"\n" + \
            ""+result[0]['lottery_loop_18']+"\n" + \
            ""+result[0]['lottery_loop_17']+"\n" + \
            ""+result[0]['lottery_loop_16']+"\n" + \
            ""+result[0]['lottery_loop_15']+"\n" + \
            ""+result[0]['lottery_loop_14']+"\n" + \
            ""+result[0]['lottery_loop_13']+"\n" + \
            ""+result[0]['lottery_loop_12']+"\n" + \
            ""+result[0]['lottery_loop_11']+"\n" + \
            ""+result[0]['lottery_loop_10']+"\n" + \
            ""+result[0]['lottery_loop_09']+"\n" + \
            ""+result[0]['lottery_loop_08']+"\n" + \
            ""+result[0]['lottery_loop_07']+"\n" + \
            ""+result[0]['lottery_loop_06']+"\n" + \
            ""+result[0]['lottery_loop_05']+"\n" + \
            ""+result[0]['lottery_loop_04']+"\n" + \
            ""+result[0]['lottery_loop_03']+"\n" + \
            ""+result[0]['lottery_loop_02']+"\n" + \
            ""+result[0]['lottery_loop_01']+"\n" + \
            "􂠁􀅦-􏿿􂠁􀅦-􏿿􂠁􀅦-􏿿􂠁􀅦-􏿿􂠁􀅦-􏿿\n" + \
            "[ เมนูบอทพิม @mybot ]" )
        except Exception as err:
            print('error ',err)

    def result_history_10line(self):
        res = requests.get('https://stockv2.ubonsoft.repl.co/index.php?loop='+self.stock_name)
        result = res.json()
        try: 
            self.mybot.sendMessage(self.message.to,result["stock"])
        except Exception as err:
            print('error ',err)
